#include "cno.hh"
#include <typeinfo>

ColourNestingOptimizer::ColourNestingOptimizer()
{
  name = "ColourNestingOptimizer";
}

inline bool IsColourTag( SMLTag* tag )
{
  return ST_r <= tag->tag && tag->tag <= ST_w ? tag : 0;
}

void
ColourNestingOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ++i ) {
    if( typeid(**i) == typeid(SMLTag) ) {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);
      Optimize( *tag );

      if( IsColourTag(tag) ) {
        SMLEntity_list_i next = i;
        ++next;
  
        for( SMLEntity_list_i j = next; j != doc.subs.end(); ) {
	  if( typeid(**j) != typeid(SMLTag) ) break;
	  SMLTag* tag2 = dynamic_cast<SMLTag*>(*j);
	  if( !IsColourTag(tag2) ) break;
  
	  if( tag2->tag == tag->tag ) {
	    tag->subs.insert( tag->subs.end(), next, j );
	    doc.subs.erase( next, j );
  
	    tag->subs.insert( tag->subs.end(), tag2->subs.begin(), tag2->subs.end() );
	    SMLEntity_list_i k = j++;
	    doc.subs.erase(k);
	    tag2->subs.clear();
	    delete tag2;
	    next = j;
	  }
	  else
	    ++j;
        }
      }
    }
  }
}
