#include "emo.hh"
#include <typeinfo>

EMEliminationOptimizer::EMEliminationOptimizer()
{
  name = "EMEliminationOptimizer";
}

void
EMEliminationOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ++i ) 
  {
    if( typeid(**i) == typeid(SMLTag) ) 
    {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);
      Optimize(*tag);
      if( tag->tag == ST_EM && IsUselessTag(*tag) )
      {
	SMLEntity_list_i j = i++;
	doc.subs.erase(j);
	doc.subs.insert( i, tag->subs.begin(), tag->subs.end() );
	tag->subs.clear();
	delete tag;
      }
    }
  }
}

bool EMEliminationOptimizer::IsUselessTag( SMLTag& tag )
{
  if( tag.subs.size() != 1 ) return false;
  
  if( typeid(*tag.subs.front()) == typeid(SMLTag) )
  {
    SMLTag* tag2 = dynamic_cast<SMLTag*>(tag.subs.front());
    if( tag2->tag == ST_EM )
    {
      tag.subs.erase(tag.subs.begin());
      tag.subs.insert(tag.subs.begin(),tag2->subs.begin(),tag2->subs.end() );
     return true;
    }
    else
    {
      return IsUselessTag(*tag2);
    }
  }
  else
  {
    return false;
  }
}
