#include "eso.hh"
#include <typeinfo>

EMSOptimizer::EMSOptimizer()
{
  name = "EMSOptimizer";
}

void
EMSOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ++i ) 
  {
    if( typeid(**i) == typeid(SMLTag) ) 
    {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);
      Optimize(*tag);
      if( tag->tag == ST_EM )
      {
	SMLEntity_list_i next, j = i;
	next = ++j;
	while( j != doc.subs.end() ) {
	  if( typeid(**j) == typeid(SMLText) ) break;
	  SMLTag* tag2 = dynamic_cast<SMLTag*>(*j);
	  if( tag2->tag != ST_S ) break;
	  ++j;
	}

	if( j != next ) {
	  tag->subs.insert( tag->subs.end(), next, j );
	  doc.subs.erase( next, j );
	}
      }
    }
  }
}
