#include "eto.hh"
#include <typeinfo>

EmptyTagOptimizer::EmptyTagOptimizer()
{
  name = "EmptyTagOptimizer";
}

void
EmptyTagOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ) {
    if( typeid(**i) == typeid(SMLTag) ) {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);
      Optimize( *tag );
      if( tag->subs.empty() ) {
	SMLEntity_list_i j = i++;
	doc.subs.erase(j);
	delete tag;
      }
      else
	++i;
    }
    else {
      SMLText* text = dynamic_cast<SMLText*>(*i);
      if( text->text == "" ) {
	SMLEntity_list_i j = i++;
	doc.subs.erase(j);
	delete text;
      }
      else
	++i;
    }
  }
}
