#include "nto.hh"
#include <typeinfo>

NeighbouringTagOptimizer::NeighbouringTagOptimizer()
{
  name = "NeighbouringTagOptimizer";
}

void
NeighbouringTagOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ++i ) {
    if( typeid(**i) == typeid(SMLTag) ) {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);

      Optimize(*tag);
      SMLEntity_list_i j = i;
      ++j;
      while( j != doc.subs.end() ) {
	if( typeid(**j) != typeid(SMLTag) ) break;
	SMLTag* tag2 = dynamic_cast<SMLTag*>(*j);
	if( tag2->cxt != tag->cxt ) break;

	tag->subs.insert( tag->subs.end(), tag2->subs.begin(), tag2->subs.end() );
	tag2->subs.clear();
	SMLEntity_list_i k = j++;
	doc.subs.erase(k);
	delete tag2;
      }
    }
  }
}
