#include "uso.hh"
#include "util.hh"
#include <typeinfo>

UselessSizeOptimizer::UselessSizeOptimizer()
{
  name = "UselessSizeOptimizer";
}

void
UselessSizeOptimizer::Optimize( SMLTag& doc )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ) {
    if( typeid(**i) == typeid(SMLTag) ) {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);

      Optimize(*tag);

      if( ST_0 <= tag->tag && tag->tag <= ST_9 && !IsSizeUsed(tag, tag->cxt.size ) ) {
	SMLEntity_list_i j = i++;
	doc.subs.erase(j);
	doc.subs.insert( i, tag->subs.begin(), tag->subs.end() );
	tag->subs.clear();
	delete tag;
      }
      else
	++i;
    }
    else
      ++i;
  }
}
