#include "wso.hh"
#include "sml.hh"
#include <typeinfo>

WhiteSpaceOptimizer::WhiteSpaceOptimizer()
{
  name = "WhiteSpaceOptimizer";
}

void
WhiteSpaceOptimizer::Optimize( SMLTag& doc )
{
  bool bWS = false;
  Context wscxt;
  Optimize( doc, wscxt, bWS );
}
  
void
WhiteSpaceOptimizer::Optimize( SMLTag& doc, Context& wscxt, bool& bWS )
{
  for( SMLEntity_list_i i = doc.subs.begin(); i != doc.subs.end(); ++i )
  {
    if( typeid(**i) == typeid(SMLTag) )
    {
      Optimize( *dynamic_cast<SMLTag*>(*i), wscxt, bWS );
    }
    else if( typeid(**i) == typeid(SMLText) )
    {
      if( doc.cxt.tt )
	bWS = false;
      else
      {
	string strIn = dynamic_cast<SMLText*>(*i)->text, strOut="";
	for( string::iterator j = strIn.begin(); j!=strIn.end(); ++j )
	{
	  if( *j < 0x21 )
	  {
	    if( !bWS || wscxt.GetSpaceContext() != doc.cxt.GetSpaceContext() )
	    {
	      strOut += (*j);
	      bWS = true;
	      wscxt = doc.cxt;
	    }
	  }
	  else
	  {
	    strOut += (*j);
	    bWS = false;
	  }
	}
	dynamic_cast<SMLText*>(*i)->text = strOut;
      }
    }
  }
}
