#include "wss.hh"
#include <typeinfo>

WhiteSpaceShifter::WhiteSpaceShifter()
{
  name = "WhiteSpaceShifter";
}

void
WhiteSpaceShifter::Optimize( SMLTag& doc )
{
  string ws = "";
  Context wscxt;
  
  SMLText* text = 0;
  Shift( doc, text, wscxt );
}

void
WhiteSpaceShifter::Shift( SMLTag& doc, SMLText*& source, Context& wscxt )
{
  for( SMLEntity_list_ri i = doc.subs.rbegin(); i != doc.subs.rend(); ++i ) {
    if( typeid(**i) == typeid(SMLTag) ) {
      SMLTag* tag = dynamic_cast<SMLTag*>(*i);
      Shift( *tag, source, wscxt );
    }
    else {
      SMLText* text = dynamic_cast<SMLText*>(*i);
      if( source && doc.cxt.GetSpaceContext() == wscxt.GetSpaceContext() &&
	  !doc.cxt.tt )
      {
	while( source->text != "" && source->text[0] < 0x21 ) {
	  text->text += source->text[0];
	  source->text = source->text.substr(1);
	}
      }
      source = text;
      wscxt = doc.cxt;
    }
  }
}
